> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/ios/standalone-modules/cafsmartauth/source-code.md).

# Source Code

```swift
import UIKit
import CafSmartAuth

class MainViewController: UIViewController {
    private var smartAuth: CafSmartAuthSdk?

    override func viewDidLoad() {
        super.viewDidLoad()
        setupCafSmartAuth()

        let verifyPolicyButton = UIButton(type: .system)
        verifyPolicyButton.setTitle("Verify Policy", for: .normal)
        verifyPolicyButton.addTarget(self, action: #selector(verifyPolicy), for: .touchUpInside)
        view.addSubview(verifyPolicyButton)

        // Layout constraints for button (if needed)
    }

    private func setupCafSmartAuth() {
        smartAuth = CafSmartAuthSdk.CafBuilder(mobileToken: "myMFAToken")
            .setStage(.prod)
            .setEmailURL(URL(string: "https://myEmailUrl.com")) // Not mandatory
            .setPhoneURL(URL(string: "https://myPhoneUrl.com")) // Not mandatory
            .setLivenessSettings(
                CafFaceLivenessSettings(
                    faceLivenessToken: "myFaceAuthToken",
                    useLoadingScreen: false,
                    filter: .lineDrawing
                )
            )
            .setThemeConfigurator(
                CafThemeConfigurator(
                    lightTheme: CafTheme(
                        backgroundColor: "#FFFFFF",
                        textColor: "#000000",
                        linkColor: "#004AF7",
                        boxBorderColor: "#cbcbcb",
                        boxFilledBorderColor: "#004AF7",
                        boxBackgroundColor: "#D3D3D3",
                        boxFilledBackgroundColor: "#D3D3D3",
                        boxTextColor: "#004AF7",
                        progressColor: "#004AF7"
                    ),
                    darkTheme: CafTheme(
                        backgroundColor: "#000000",
                        textColor: "#FFFFFF",
                        linkColor: "#004AF7",
                        boxBorderColor: "#cbcbcb",
                        boxFilledBorderColor: "#004AF7",
                        boxBackgroundColor: "#D3D3D3",
                        boxFilledBackgroundColor: "#D3D3D3",
                        boxTextColor: "#004AF7",
                        progressColor: "#004AF7"
                    )
                )
            )
            .build()
    }

    @objc private func verifyPolicy() {
        smartAuth?.verifyPolicy(
            personID: "userDocument",
            policyId: "myPolicyId",
            listener: setupListener()
        )
    }

    private func setupListener() -> CafVerifyPolicyListener {
        return { result in
            switch result {
            case .onSuccess(let response):
                print("CafVerifyPolicyListener.onSuccess isAuthorized: \(response.isAuthorized)")
                print("CafVerifyPolicyListener.onSuccess attestation: \(response.attestation)")

            case .onPending(let response):
                print("CafVerifyPolicyListener.onPending isAuthorized: \(response.isAuthorized)")
                print("CafVerifyPolicyListener.onPending attestation: \(response.attestation)")

            case .onError(let error):
                print("CafVerifyPolicyListener.onError failure: \(error.localizedDescription)")

            case .onCanceled(let error):
                print("CafVerifyPolicyListener.onCanceled failure: \(error.localizedDescription)")

            case .onLoading(let isLoading):
                print("CafVerifyPolicyListener.onLoading isLoading: \(isLoading)")

            case .onLoaded(let isLoaded):
                print("CafVerifyPolicyListener.onLoaded isLoaded: \(isLoaded)")
            }
        }
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.caf.io/caf-sdk/ios/standalone-modules/cafsmartauth/source-code.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
